<?php
    namespace VENDEX;
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');


          
    class ConfiguracionController
    {
    
        public function __construct()
        {
    
        }

        public static function index(){

            global $wpdb;

            $query="SELECT p.id, p.post_date,  po.meta_value, s.total_sales, v.observacion
            FROM wp_posts p
            INNER JOIN wp_postmeta po ON po.post_id = p.id AND po.meta_key = '_billing_first_name'
            INNER JOIN wp_wc_order_stats s ON s.order_id = p.id 
            INNER JOIN vendex v ON v.id_order = p.id AND v.status_order = 0 
            ORDER BY p.post_date
            ";
            $ordenesFallidas =  $wpdb->get_results($query);    


            $token_vendex = get_option('token_vendex');
            $html = '';
            $html_encabezado = '
            <p><strong><img src="https://vendex.ec/images/logo-load-1.gif" alt="" width="70" height="70" />&nbsp; Vendex Ecuador</strong></p>
            <p>&nbsp;</p>
            <div>Mira este corto video de como configurar tu sistema para emitir facturas electrónicas</div>
            <p><iframe src="//www.youtube.com/embed/5mBk6pNuo4Y" width="560" height="314" allowfullscreen="allowfullscreen"></iframe>&nbsp;</p>
            <br>
            <br>            
            ';

            if(isset($token_vendex) && $token_vendex != null){
                $html =  $html_encabezado.'
                <p style="
                font-size: large;
                color: #0078c1;
                ">Su token ha sido validado. Ya puede facturar.</p>
                <form method="POST">
                <input type="hidden" name="eliminar_token"></div>
                <div><input type="submit"  value="Cambiar Token"  style="
                color: #fff;
                padding: 8px 40px;
                border:none;
                border-radius: 15px;
                outline:none;
                font-size:15px;
                text-shadow:-2px 2px 0 rgba(0,0,0,0.2);
                font-weight: 700;
                transition: all .1s linear;
                background: linear-gradient(to bottom,#55a3d5,#3093cd);
                box-shadow: -1px 0 1px #ff4c80, 0 1px 1px #ff1f61, -2px 1px 1px #fd608e, -1px 2px 1px #ff1f61, -3px 2px 1px #fc749b;
                " /></div>
            </form>    
        
                ';            

            }else{
                $html =  $html_encabezado.'
                <p>Por favor ingrese el token de su sistema Vendex Ecuador y presione Guardar.</p>
                <form method="POST">
                    <div><b>Token:</b> <input type="text" name="token_vendex" value="'. get_option('token_vendex').'"></div>
                    <br>
                    <div><input type="submit" value="Guardar"  style="
                    color: #fff;
                    border-radius: 15px;
                    padding: 8px 40px;
                    border:none;
                    outline:none;
                    font-size:15px;
                    text-shadow:-2px 2px 0 rgba(0,0,0,0.2);
                    font-weight: 700;
                    transition: all .1s linear;
                    background: linear-gradient(to bottom,#55a3d5,#3093cd);
                    box-shadow: -1px 0 1px #ff4c80, 0 1px 1px #ff1f61, -2px 1px 1px #fd608e, -1px 2px 1px #ff1f61, -3px 2px 1px #fc749b;
                    " /></div>
                </form>    
                <p>&nbsp;</p>
                ';            
    
            }


            $ordenesNoProcesadas = '<br>';

            if(isset($ordenesFallidas) && count($ordenesFallidas) > 0 && isset($token_vendex) && strlen($token_vendex) >0){
                $ordenesNoProcesadasEncabezado = '
            
                <style>
                    #customers {
                      font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
                      border-collapse: collapse;
                      width: 100%;
                    }
    
                    #customers td, #customers th {
                      border: 1px solid #ddd;
                      padding: 8px;
                    }
    
                    #customers tr:nth-child(even){background-color: #f2f2f2;}
    
                    #customers tr:hover {background-color: #ddd;}
    
                    #customers th {
                      padding-top: 12px;
                      padding-bottom: 12px;
                      text-align: center;
                      background-color: #55a3d5;
                      color: white;
                    }
    
                    .tituloPrincipal{
                        padding-top: 12px;
                        padding-bottom: 12px;
                        text-align: center;
                        background-color: #ff326b;
                        color: white;
                    }
    
                </style>
                
                <table style="width:80%" id="customers">
                <tr>
                    <td colspan="6" align="center" class="tituloPrincipal">Ordenes no Facturadas Electrónicamente</td>
                </tr>
                <tr>
                  <th align="center" style="width:10%">N. de Orden</th>
                  <th align="center" style="width:10%">Fecha</th>
                  <th align="center">Cliente</th>
                  <th align="center" style="width:10%">Valor Total</th>
                  <th align="center">Observación</th>
                  <th align="center">Reenviar</th>
                </tr>';
    
                $ordenesNoProcesadasCuerpo = '';
    
    
                foreach ($ordenesFallidas as $of) {
                    $ordenesNoProcesadasCuerpo .= '
                    <form method="POST">
                    <tr>
                        <td align="center">'.$of->id.'<input type="hidden" name="reenviar" value="'.$of->id.'"></td>
                        <td align="center">'.$of->post_date.'</td>
                        <td>'.$of->meta_value.'</td>
                        <td align="center">$'.$of->total_sales.'</td>
                        <td>'.$of->observacion.'</td>
                        <td align="center"><input type="submit" value="Reenviar" style="background-color: #55a3d5;
                        border-radius: 15px;
                        color: white;
                        padding: 5px 20px;
                        box-shadow: -1px 0 1px #ff4c80, 0 1px 1px #ff1f61, -2px 1px 1px #fd608e, -1px 2px 1px #ff1f61, -3px 2px 1px #fc749b;"
                    }
                    
                    "></td>
                    </tr>
                    </form>
                    ';            
                }    
    
              $ordenesNoProcesadasPie = '
              </table>
              ';
    
              $ordenesNoProcesadas .= $ordenesNoProcesadasEncabezado.$ordenesNoProcesadasCuerpo.$ordenesNoProcesadasPie;
                    
            }else if(isset($token_vendex) && strlen($token_vendex) >0) {
                $ordenesNoProcesadas = '<p style="
                font-size: large;
                color: #0078c1;
                ">Todas sus facturas se han procesado exitosamente</p>';
            }



            echo $html.$ordenesNoProcesadas;


        }


        public static function reenviar(){
            global $wpdb;

            $id_reenvio=  $_POST['reenviar'];

            if(isset($id_reenvio) && $id_reenvio > 0){

                $token_vendex = get_option('token_vendex');
                $sitio_url = get_option('siteurl');
                $url = 'https://vendexnet.com/api/registro/ecommercePlugin/nuevoPedidoPlugin';
                $ch = curl_init($url);
                $data = array(
                    'idPedido' => $id_reenvio,
                    'tokenFacturacion' => $token_vendex,
                    'urlSitio' => $sitio_url
                );
                $payload = json_encode( $data);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 20);
                curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                $result = curl_exec($ch);
    
                $resultado_arreglo = json_decode($result, true);

                if(isset($result) && $resultado_arreglo['operationStatus'] == 'SUCCESS'){
                    $query="UPDATE vendex  SET status_order = 1  WHERE id_order =".$id_reenvio;
                    $wpdb->query($query);            
                }else{
                    $observacion = isset($resultado_arreglo['operationMessage']) ? $resultado_arreglo['operationMessage'] : 'No se ha podido conectarx.';
                    $query="UPDATE vendex  SET observacion = '$observacion'  WHERE id_order =".$id_reenvio;
                    $wpdb->query($query);            
                }
    
            }



        }


        public static function guardar(){

            $token_vendex = get_option('token_vendex');
            $sitio_url = get_option('siteurl');
            $url = 'https://vendexnet.com/api/registro/ecommercePlugin/validacionToken';
            $ch = curl_init($url);
            $data = array(
                'idPedido' => 0,
                'tokenFacturacion' => $_POST['token_vendex'],
                'urlSitio' => $sitio_url
            );
            $payload = json_encode( $data);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $result = curl_exec($ch);
            curl_close($ch);    

            if($result == 'true'){
                update_option('token_vendex', $_POST['token_vendex']);
            }


        }

        public static function eliminar(){
            delete_option( 'token_vendex' );
        }

        public static function mostrar(){
            if(get_option('token_vendex')=='si')
            {
                $html='<style>
                @import url("https://fonts.googleapis.com/css?family=Pacifico&display=swap");
                html *{font-family: "Pacifico", cursive;}
                </style>';
                echo $html;
            }
        }


    }