<?php
    namespace VENDEX;

    class FacturacionController
    {
    
        public function __construct()
        {
        }

        function envio_vendex($post_id) {
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            global $wpdb;

            $token_vendex = get_option('token_vendex');
            $sitio_url = get_option('siteurl');
            $url = 'https://vendexnet.com/api/registro/ecommercePlugin/nuevoPedidoPlugin';
            $ch = curl_init($url);
            $data = array(
                'idPedido' => $post_id,
                'tokenFacturacion' => $token_vendex,
                'urlSitio' => $sitio_url
            );
            $payload = json_encode( $data);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 20);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            $result = curl_exec($ch);

            $resultado_arreglo = json_decode($result, true);

            if(isset($result) && $resultado_arreglo['operationStatus'] == 'SUCCESS'){
                $observacion = $resultado_arreglo['operationMessage'];
                $query="INSERT INTO vendex (id_order, status_order, observacion) VALUES ('$post_id',1,'$observacion')";
                $resultadoSQL =  $wpdb->query($query);    
            }else{
                $observacion = isset($resultado_arreglo['operationMessage']) ? $resultado_arreglo['operationMessage'] : 'No se ha podido conectar.';
                $query="INSERT INTO vendex (id_order, status_order, observacion) VALUES ('$post_id',0,'$observacion')";
                $resultadoSQL =  $wpdb->query($query);    
            }


            curl_close($ch);    
        }

    }